com.microfocus.awm.model

## Interface ISystemProvider

- All Known Implementing Classes:
    AbstractLocalSystemProvider, DefaultConfigurationSystemProvider, LocalSystemProvider

      public interface ISystemProvider

  Provides `ITaurusSystemProxy`s for users to create `ITaurusSystem`s at runtime. Is also responsible for restoring cached AWM systems on restart.

  System providers can be registered by extensions of the `com.microfocus.awm.systemprovider` extension point.

  Copyright Micro Focus GmbH.

  Author:
    Ralf Pakosch

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getID()` Gets the unique ID of the system provider as defined in the extension.
    `java.util.List<ISystemImage>` | `getRemoteSystemImages()` Returns a list of remote system images, if the system provider supports AWM systems which are created from remote system connections.
    `java.util.List<ITaurusSystemProxy>` | `getSystemProxies()` Gets a list of `ITaurusSystemProxy`s.
    `ITaurusSystem` | `loadPersistedSystem(TaurusSystemPersistableProxy pPersistableProxy)` Creates an `ITaurusSystem` from its persistable proxy representation.

- - ### Method Detail

    - #### getSystemProxies

          java.util.List<ITaurusSystemProxy> getSystemProxies()
                                                       throws TaurusCoreException

      Gets a list of `ITaurusSystemProxy`s.
      Returns:
        a list of system proxies
      Throws:
        `TaurusCoreException` - if retrieving the system proxies fails

    - #### getID

          java.lang.String getID()

      Gets the unique ID of the system provider as defined in the extension.
      Returns:
        the ID of the system provider

    - #### loadPersistedSystem

          ITaurusSystem loadPersistedSystem(TaurusSystemPersistableProxy pPersistableProxy)
                                     throws TaurusCoreException

      Creates an `ITaurusSystem` from its persistable proxy representation. The persistable proxy will be created from loading the AWM system cache.
      Parameters:
        `pPersistableProxy` - the AWM system representation
      Returns:
        the `ITaurusSystem` or `null` if the provider cannot load a system from cache
      Throws:
        `TaurusCoreException` - if creating the AWM system failed

    - #### getRemoteSystemImages

          java.util.List<ISystemImage> getRemoteSystemImages()
                                                      throws TaurusCoreException

      Returns a list of remote system images, if the system provider supports AWM systems which are created from remote system connections. This is used e.g. for associating local AWM systems to remote systems.
      Returns:
        a list of system images or `null` if the provider does not support any.
      Throws:
        `TaurusCoreException` - if an exception occurs during getting the list of remote system images

Copyright © 2015 Micro Focus GmbH. All rights reserved.